package com.taauav.admin.controller;

import com.taauav.common.bean.Response;
import com.taauav.common.constant.PermissionConstants;
import com.taauav.admin.service.IStatisticsService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * <p>数据统计</p>
 *
 * @author : dyg
 * @date : 2019-12-05 16:22
 **/
@RestController
@RequestMapping("statistics")
public class StatisticsController {
    @Autowired
    private IStatisticsService iStatisticsService;


    /**
     * 报告统计
     * @param map
     * @return
     */
    @PostMapping("index")
    @RequiresPermissions("statistics:" + PermissionConstants.LIST_PERMISSION)
    public Response index(@RequestBody(required = false) Map<String,String> map) {
        return iStatisticsService.getStatisticsDataIndex(map);
    }

    /**
     * 获取区域河道列表
     * @param map
     * @return
     */
    @PostMapping("area")
    @RequiresPermissions("statistics:area")
    public Response area(@RequestBody(required = false) Map<String,String> map) {
        return iStatisticsService.getAreaStaticsData(map);
    }

    /**
     * 根据报告编号获取数据
     * @param reportId
     * @return
     */
    @GetMapping("reportInfo")
    @RequiresPermissions("statistics:reportInfo")
    public Response getInfoByReportId(@RequestParam("reportId") Integer reportId,String fileDocument) {
        return iStatisticsService.getInfoByReportId(reportId,fileDocument);
    }
}
