package com.taauav.admin.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 任务信息展示
 *
 * @author dyg
 * @date 2019/11/22
 */
@Data
public class TauvInspectDriverDTO extends BaseInspectDriverDTO {
    /**
     * 飞行小组
     */
    private String flightGroup;
    private String flightGroupText;
    /**
     * 添加时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;
    private String formatCreateTime;
    /**
     * 添加人
     */
    private Integer createUser;
    private String formatCreateUser;
    /**
     * 状态
     */
    private Integer status;
    private String statusText;

    /**
     * 任务类型
     */
    private Integer type;
    private String typeText;

    /**
     * 期望巡检时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date inspectTime;
    private String formatInspectTime;

    /**
     * 巡检长度
     */
    private BigDecimal inspectLength;

//    /**
//     * 执行周期（如：每月10号）
//     */
//    private String executionCycle;

    /**
     * 报告创建时间
     */
    private String formatInputTime;

    /**
     * 河流起点
     */
    private String driverStart;

    /**
     * 河流终点
     */
    private String driverEnd;

    /**
     * 执行开始时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date executionStartTime;
    private String formatExecutionStartTime;

    /**
     * 执行结束时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date executionEndTime;
    private String formatExecutionEndTime;

    /**
     * 飞行时长
     */
    private BigDecimal flightTime;

    /**
     * 河道长度
     */
    private BigDecimal driverLength;
}
