package com.taauav.admin.mapper;

import com.taauav.admin.entity.TauvInspectFile;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 巡检附件表 Mapper 接口
 * </p>
 *
 * @author dyg
 * @since 2019-11-14
 */
public interface TauvInspectFileMapper extends BaseMapper<TauvInspectFile> {
    List<TauvInspectFile> getListByInspectDriverIds(@Param("inspectDriverIds") Integer[] inspectDriverIds);
    /**
     * 根据河道类型获取问题图片的数量
     * @param driverArea
     * @param inspectDriverId
     * @param driverExam
     * @param inspectStartTime
     * @param inspectEndTime
     * @return
     */
    List<Map<String,Object>> getNumByFileDocument(@Param("driverArea") String[] driverArea, @Param("inspectDriverId") Integer inspectDriverId, @Param("driverExam") Byte driverExam, @Param("inspectStartTime") Integer inspectStartTime, @Param("inspectEndTime") Integer inspectEndTime);
}
