package com.taauav.admin.service;

import com.taauav.common.bean.Response;
import com.taauav.admin.entity.SysAdmin;
import com.taauav.common.service.IBaseService;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 管理员表 服务类
 * </p>
 *
 * @author dyg
 * @since 2019-11-04
 */
public interface ISysAdminService extends IBaseService<SysAdmin> {
    /**
     * 根据用户获取数据
     * @param username
     * @return
     */
    SysAdmin findByUsername(String username);

    /**
     * 根据用户编号获取数据
     * @param id
     * @return
     */
    SysAdmin findById(Integer id);

    /**
     * 用户登录
     * @param username
     * @param password
     * @return
     */
    Response login(String username, String password);

    /**
     * 用户退出
     */
    void logout();

    /**
     * 获取管理员列表数据
     * @param map
     * @return
     */
    Response findAdminPageList(Map<String,String> map);

    /**
     * 获取管理员数据
     * @param id
     * @return
     */
    SysAdmin getAdminInfo(Integer id);

    /**
     * 保存编辑管理员数据
     * @param map
     * @return
     */
    Response editAdminInfo(SysAdmin map);

    /**
     * 处理管理员mark标记、状态或密码
     * @param map
     * @return
     */
    Response dealAdmin(Map<String, String> map);

    /**
     * 获取权限数据
     * @param map
     * @return
     */
    Response getPermit(Map<String, String> map);

    /**
     * 设置权限
     * @param map
     * @return
     */
    Response setPermit(Map<String, String> map);
    /**
     * 获取管理员一维数组
     * @return
     */
    Response getAdminList();

    /**
     * 获取角色一维数组
     * @return
     */
    Response getAuthGroupList();

    /**
     * 根据id获取账户姓名
     * @param id
     * @return
     */
    String getRealNameById(Integer id);

    List<Map<String,Object>> getAdminListByGroupId(Integer groupId);
}
