package com.taauav.admin.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.taauav.common.bean.Response;
import com.taauav.admin.entity.SysDep;
import com.taauav.admin.mapper.SysAdminMapper;
import com.taauav.admin.mapper.SysDepMapper;
import com.taauav.admin.service.ISysAdminService;
import com.taauav.admin.service.ISysDepService;
import com.taauav.common.service.impl.BaseServiceImpl;
import com.taauav.common.util.DateUtil;
import com.taauav.common.util.ShiroUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.validation.ConstraintViolation;
import javax.validation.Validator;
import java.time.LocalDateTime;
import java.util.*;

/**
 * <p>
 * 部门管理表 服务实现类
 * </p>
 *
 * @author dyg
 * @since 2019-11-07
 */
@Service
public class SysDepServiceImpl extends BaseServiceImpl<SysDepMapper, SysDep> implements ISysDepService {
    @Resource
    private Response response;
    @Autowired
    private SysDepMapper sysDepMapper;
    @Autowired
    private SysAdminMapper adminMapper;
    @Resource
    private Validator validator;
    @Autowired
    private ISysAdminService adminService;

    /**
     * 获取部门数据
     *
     * @return
     */
    @Override
    public Response index() {
        QueryWrapper wrapper = new QueryWrapper();
        wrapper.eq("mark", 1);
        wrapper.eq("pid", 0);
        wrapper.orderByAsc("sort");
        List<SysDep> depList = list(wrapper);
        List<Map<String, Object>> list = new ArrayList<>();
        if (depList != null) {
            depList.forEach(sysDep -> {
                Map<String, Object> map = new HashMap<>();
                map.put("id", String.valueOf(sysDep.getId()));
                map.put("name", sysDep.getName());
                map.put("sort", String.valueOf(sysDep.getSort()));
                map.put("hasChild", sysDep.getHasChild());
                map.put("manager", sysDep.getManager());
                String managerName = "";
                if (sysDep.getManager() != null && sysDep.getManager() > 0) {
                    managerName = adminService.getRealNameById(sysDep.getManager());
                }
                map.put("managerName", managerName);
                String managerNm = "";
                if (sysDep.getManager() > 0) {
                    managerNm = adminService.getRealNameById(sysDep.getManager());
                }
                map.put("managerName", managerNm);
                String pCreateUser = "";
                if (sysDep.getCreateUser() > 0) {
                    pCreateUser = adminService.getRealNameById(sysDep.getCreateUser());
                }
                map.put("createUserName", pCreateUser);
                String pCreateTime = "";
                if (sysDep.getCreateTime() != null) {
                    pCreateTime = sysDep.getCreateTime().toString();
                }
                map.put("formatCreateTime", pCreateTime);
                Integer hasChild = sysDep.getHasChild();
                if (Integer.valueOf(hasChild) == 1) {
                    QueryWrapper wrp = new QueryWrapper();
                    wrp.eq("mark", 1);
                    wrp.eq("pid", sysDep.getId());
                    wrp.orderByAsc("sort");
                    List<SysDep> childList = list(wrp);
                    List<Map<String, Object>> firstChild = new ArrayList<>();
                    if (childList != null) {
                        childList.forEach(child -> {
                            Map<String, Object> vl = new HashMap<>();
                            vl.put("id", String.valueOf(child.getId()));
                            vl.put("name", child.getName());
                            vl.put("sort", String.valueOf(child.getSort()));
                            vl.put("pid", child.getPid());
                            vl.put("hasChild", child.getHasChild());
                            vl.put("manager", child.getManager());
                            String manager = "";
                            if (child.getManager() != null && child.getManager() > 0) {
                                manager = adminService.getRealNameById(child.getManager());
                            }
                            vl.put("managerName", manager);
                            String pManagerName = "";
                            if (child.getManager() > 0) {
                                pManagerName = adminService.getRealNameById(child.getManager());
                            }
                            vl.put("managerName", pManagerName);
                            String fCreateUser = "";
                            if (child.getCreateUser() > 0) {
                                fCreateUser = adminService.getRealNameById(child.getCreateUser());
                            }
                            vl.put("createUserName", fCreateUser);
                            String fCreateTime = "";
                            if (child.getCreateTime() != null) {
                                fCreateTime = child.getCreateTime().toString();
                            }
                            vl.put("formatCreateTime", fCreateTime);
                            if (Integer.valueOf(child.getHasChild()) == 1) {
                                QueryWrapper wp = new QueryWrapper();
                                wp.eq("mark", 1);
                                wp.eq("pid", child.getId());
                                wp.orderByAsc("sort");
                                List<SysDep> cList = list(wp);
                                if (cList != null) {
                                    List<Map<String, Object>> thirdChild = new ArrayList<>();
                                    cList.forEach(cl -> {
                                        Map<String, Object> cld = new HashMap<>();
                                        cld.put("id", String.valueOf(cl.getId()));
                                        cld.put("name", cl.getName());
                                        cld.put("sort", String.valueOf(cl.getSort()));
                                        cld.put("pid", cl.getPid());
                                        cld.put("hasChild", cl.getHasChild());
                                        cld.put("manager", cl.getManager());
                                        String manName = "";
                                        if (cl.getManager() > 0) {
                                            manName = adminService.getRealNameById(cl.getManager());
                                        }
                                        cld.put("managerName", manName);
                                        String createUserName = "";
                                        if (cl.getCreateUser() > 0) {
                                            createUserName = adminService.getRealNameById(cl.getCreateUser());
                                        }
                                        cld.put("createUserName", createUserName);
                                        String formatCreateTime = "";
                                        if (cl.getCreateTime() != null) {
                                            formatCreateTime = cl.getCreateTime().toString();
                                        }
                                        cld.put("formatCreateTime", formatCreateTime);
                                        thirdChild.add(cld);
                                    });
                                    vl.put("children", thirdChild);
                                }
                            }
                            firstChild.add(vl);
                        });
                    }
                    map.put("children", firstChild);
                }
                list.add(map);
            });
        }
        return response.success("操作成功", list);
    }

    /**
     * 获取某个部门信息
     *
     * @param id
     * @return
     */
    @Override
    public Response getDepInfo(Integer id) {
        if (id <= 0 || id.equals(null)) {
            return response.failure("部门ID不存在");
        }
        QueryWrapper wrapper = new QueryWrapper();
        wrapper.eq("mark", 1);
        wrapper.eq("id", id);
        Map<String, Object> depInfo = getMap(wrapper);
        if (depInfo == null) {
            return response.failure("部门信息不存在");
        }
        //主管姓名
        String managerName = "";
        String manager = "manager";
        if ((Integer) depInfo.get(manager) > 0) {
            managerName = adminService.getRealNameById((Integer) depInfo.get("manager"));
        }
        depInfo.put("managerName", managerName);
        //添加人姓名
        String createUserName = "";
        Integer create = new Long((Long) depInfo.get("create_user")).intValue();
        if (create > 0) {
            createUserName = adminService.getRealNameById(create);
        }
        depInfo.put("createUserName", createUserName);
        return response.success("操作成功", depInfo);
    }

    /**
     * 保存编辑数据
     *
     * @param map
     * @return
     */
    @Override
    public Response edit(SysDep map) {
        //必填字段及格式校验
        Set<ConstraintViolation<SysDep>> violations = validator.validate(map);
        for (ConstraintViolation<SysDep> violation : violations) {
            if (!"".equals(violation.getMessage())) {
                return response.failure(violation.getMessage());
            }
        }

        SysDep dep = new SysDep();
        Integer id = map.getId();
        if (id == null) {
            dep.setCreateUser(ShiroUtils.getAdminId());
            dep.setCreateTime(DateUtil.now());
        } else {
            dep.setId(id);
            dep.setUpdateUser(ShiroUtils.getAdminId());
            dep.setUpdateTime(DateUtil.now());
        }
        dep.setName(map.getName());
        dep.setPid(map.getPid());
        Integer level = 1;
        if (map.getPid() != null && map.getPid() > 0) {
            SysDep pInfo = sysDepMapper.selectById(map.getPid());
            if (pInfo != null) {
                level = pInfo.getLevel() + 1;
            }
        }
        dep.setLevel(level);
        dep.setManager(map.getManager());
        dep.setHasChild(map.getHasChild());
        dep.setSort(map.getSort());
        Boolean res = true;
        if (id != null && id > 0) {
            res = updateById(dep);
        } else {
            res = save(dep);
        }
        if (res.equals(false)) {
            return response.failure("操作失败");
        }
        return response.success("操作成功");
    }

    /**
     * 删除部门操作
     *
     * @param map
     * @return
     */
    @Override
    public Response drop(Map<String, String> map) {
        String id = map.getOrDefault("id", "0");
        if (Integer.valueOf(id) == 0) {
            return response.failure("部门id不能为空");
        }
        SysDep depInfo = sysDepMapper.selectById(Integer.valueOf(id));
        if (depInfo == null) {
            return response.failure("部门信息不存在");
        }
        boolean result = this.deleteById(Integer.valueOf(id), depInfo);
        if (!result) {
            return response.failure("删除失败");
        }
        return response.success("操作成功");
    }
}
