package com.taauav.admin.service.impl;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.taauav.admin.entity.TauvDriverPoint;
import com.taauav.admin.mapper.TauvDriverPointMapper;
import com.taauav.admin.service.ITauvDriverPointService;
import com.taauav.common.service.impl.BaseServiceImpl;
import com.taauav.common.util.RedisUtils;
import com.taauav.common.util.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 河道坐标
 * @author dyg
 */
@Service
public class TauvDriverPointServiceImpl extends BaseServiceImpl<TauvDriverPointMapper, TauvDriverPoint> implements ITauvDriverPointService {
    @Autowired
    private RedisUtils redisUtils;
    @Override
    public List<TauvDriverPoint> getListByDriverId(int driverId) {
        List<TauvDriverPoint> pointList = null;
        String key = "driver_point_"+driverId;
        pointList = (List<TauvDriverPoint>)redisUtils.get(key);
        if (StringUtils.isEmpty(pointList)) {
            QueryWrapper<TauvDriverPoint> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("driver_id", driverId);
            queryWrapper.eq("mark", 1);
            pointList = list(queryWrapper);
            redisUtils.set(key, pointList);
        }
        return pointList;
    }
}
