package com.taauav.common.util;

import java.io.Serializable;

/**
 * describe:
 *
 * @author matengfei
 * @date 2019/10/31
 */
public class JsonUtil<T> implements Serializable {

    private String message;
    private Integer status;
    private Object data;

    public JsonUtil() {

    }

    public JsonUtil(Integer status) {
        this.status =status;
    }

    public JsonUtil(Integer status, String message) {
        this.status = status;
        this.message = message;
    }

    public JsonUtil(Integer status, String msg, T data) {
        this.status = status;
        this.message = msg;
        this.data = data;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Object getData() {
        return data;
    }

    public void setData(Object data) {
        this.data = data;
    }

    public static JsonUtil error(String msg) {
        return new JsonUtil(-1, msg);
    }

    public static JsonUtil success(String msg) {
        return new JsonUtil(1, msg);
    }

    public static JsonUtil success(String msg, Object data) {
        return  new JsonUtil(1,msg,data);
    }
}
