package com.taauav.common.util;

import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Component;

/**
 * <p>Spring上下文工具类</p>
 *
 * @author : dyg
 * @date : 2019-12-04 11:28
 **/
@Component
public class SpringUtil implements ApplicationContextAware {

    private static ApplicationContext context;
    @Override
    public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        context = applicationContext;
    }

    /**
     * 通过Name返回指定的Bean
     * @param beanClass
     * @param <T>
     * @return
     */
    public static  <T> T getBean(Class<T> beanClass) {
        return context.getBean(beanClass);
    }
}
